#include "StdAfx.h"
#include "MusicItem.h"

/****************************************************************/
/*					O[oϐiNXǁEEEj		*/
/****************************************************************/
extern	OPSW*			cOptionSW;	//IvVւ̃|C^ϐ

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		MusicFile*	SND
//		int			iOffset
//	Ԓl
//				
//==============================================================
MusicItem::MusicItem(const char _strName[]):
	iOffset(0),
	strName(_strName)
{
	//Debug message@io͂̂ŒӁBj
	if(cOptionSW->cDebug & 0x01){
		cout << "Create Music Object : " << strName << endl;
	}
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
MusicItem::~MusicItem(void)
{
	//----------------------
	//Localϐ
	vector<	MusicItem*>::iterator	itItem;

	//----------------------
	//Delete Class
	if(!ptcItem.empty()){
		itItem = ptcItem.begin();
		while(itItem != ptcItem.end()){
			delete *itItem;
			itItem++;
		}
		ptcItem.clear();
	}
}

//==============================================================
//		R[hTCY̎擾
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
unsigned	int		MusicItem::getSize()
{
	return(iSize);
}

//==============================================================
//		R[h̃ItZbgAhX̎擾
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
unsigned	int		MusicItem::getOffset()
{
	return(iOffset);
}

//==============================================================
//		ItZbgAhX̐ݒ
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
unsigned	int		MusicItem::SetOffset(unsigned	int _offset)
{
	//----------------------
	//Localϐ
	vector<	MusicItem*>::iterator	itItem;

	//Debug message@io͂̂ŒӁBj
	if(cOptionSW->cDebug & 0x02){
		cout << "Object Address [0x" << hex << _offset << dec << "]: " << strName << endl;
	}

	iOffset = _offset;
	_offset	+= code.size();

	if(!ptcItem.empty()){
		itItem = ptcItem.begin();
		while(itItem != ptcItem.end()){
			_offset = (*itItem)->SetOffset(_offset);
			itItem++;
		}
	}

	return(_offset);
}

//==============================================================
//		R[h̎擾
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MusicItem::getCode(string* _str)
{
	//----------------------
	//Localϐ
	vector<	MusicItem*>::iterator	itItem;

	_str->append(code);

	if(!ptcItem.empty()){
		itItem = ptcItem.begin();
		while(itItem != ptcItem.end()){
			(*itItem)->getCode(_str);
			itItem++;
		}
	}
}
